Reload the Xinerama layout on RandR signal. This is probably just a workaround
for some issues, not a final solution -- but it points out the problems.
    Tomas Janousek <tomi@nomi.cz>

Index: src/Screen.cc
===================================================================
--- src/Screen.cc	(revision 4723)
+++ src/Screen.cc	(working copy)
@@ -371,6 +371,12 @@
 
     Display *disp = m_root_window.display();
 
+    // TODO fluxgen: check if this is the right place (it was not -lis)
+    //
+    // Create the first one, initXinerama will expand this if needed.
+    m_head_areas.resize(1);
+    m_head_areas[0] = new HeadArea();
+
     initXinerama();
 
     // setup error handler to catch "screen already managed by other wm"
@@ -404,9 +410,6 @@
         XFree(ret_prop);
     }
 
-    // TODO fluxgen: check if this is the right place
-    m_head_areas = new HeadArea[numHeads() ? numHeads() : 1];
-
     _FB_USES_NLS;
 
     fprintf(stderr, _FB_CONSOLETEXT(Screen, ManagingScreen,
@@ -596,7 +599,8 @@
     m_slit.reset(0);
 
     // TODO fluxgen: check if this is the right place
-    delete [] m_head_areas;
+    for (int i = 0; i < m_head_areas.size(); i++)
+	delete m_head_areas[i];
 
     delete m_focus_control;
     delete m_placement_strategy;
@@ -713,7 +717,7 @@
 }
 
 const Strut* BScreen::availableWorkspaceArea(int head) const {
-    return m_head_areas[head ? head-1 : 0].availableWorkspaceArea();
+    return m_head_areas[head ? head-1 : 0]->availableWorkspaceArea();
 }
 
 unsigned int BScreen::maxLeft(int head) const {
@@ -1475,7 +1482,7 @@
 
     Strut* next = 0;
     for (int i = begin; i != end; i++) {
-        next = m_head_areas[i].requestStrut(i+1, left, right, top, bottom, next);
+        next = m_head_areas[i]->requestStrut(i+1, left, right, top, bottom, next);
     }
 
     return next;
@@ -1485,7 +1492,7 @@
     if (str->next())
         clearStrut(str->next());
     int head = str->head() ? str->head() - 1 : 0;
-    m_head_areas[head].clearStrut(str);
+    m_head_areas[head]->clearStrut(str);
     // str is invalid now
 }
 
@@ -1494,7 +1501,7 @@
     bool updated = false;
 
     for (size_t i = 0; i < n; i++) {
-        updated = m_head_areas[i].updateAvailableWorkspaceArea() || updated;
+        updated = m_head_areas[i]->updateAvailableWorkspaceArea() || updated;
     }
 
     if (updated)
@@ -2065,6 +2072,9 @@
 }
 
 void BScreen::updateSize() {
+    // update xinerama layout
+    initXinerama();
+
     // force update geometry
     rootWindow().updateGeometry();
 
@@ -2124,6 +2134,8 @@
         cerr<<"BScreen::initXinerama(): dont have Xinerama"<<endl;
 #endif // DEBUG
         m_xinerama_avail = false;
+	if (m_xinerama_headinfo)
+	    delete [] m_xinerama_headinfo;
         m_xinerama_headinfo = 0;
         m_xinerama_num_heads = 0;
         return;
@@ -2136,6 +2148,8 @@
     XineramaScreenInfo *screen_info;
     int number;
     screen_info = XineramaQueryScreens(display, &number);
+    if (m_xinerama_headinfo)
+	delete [] m_xinerama_headinfo;
     m_xinerama_headinfo = new XineramaHeadInfo[number];
     m_xinerama_num_heads = number;
     for (int i=0; i < number; i++) {
@@ -2149,6 +2163,13 @@
     cerr<<"BScreen::initXinerama(): number of heads ="<<number<<endl;
 #endif // DEBUG
 
+    // We have to allocate additional HeadAreas, but never delete existing
+    // ones, it would just crash. -lis
+    int ha_num = numHeads() ? numHeads() : 1, ha_oldnum = m_head_areas.size();
+    m_head_areas.resize(ha_num);
+    for (int i = ha_oldnum; i < ha_num; i++)
+	m_head_areas[i] = new HeadArea();
+
 #else // XINERAMA
     // no xinerama
     m_xinerama_avail = false;
Index: src/Screen.hh
===================================================================
--- src/Screen.hh	(revision 4723)
+++ src/Screen.hh	(working copy)
@@ -482,7 +482,7 @@
     int m_xinerama_num_heads;
     int m_xinerama_center_x, m_xinerama_center_y;
 
-    HeadArea *m_head_areas;
+    std::vector<HeadArea *> m_head_areas;
 
     struct XineramaHeadInfo {
         int x, y, width, height;        
